--- old/usr/src/tools/smatch/src/smatch_function_hooks.c	Tue Jan  7 08:01:55 2020
+++ new/usr/src/tools/smatch/src/smatch_function_hooks.c	Tue Jan  7 08:01:55 2020
@@ -1078,6 +1078,7 @@
 	value = argv[5];
 
 	if (db_info->prev_return_id != -1 && type == INTERNAL) {
+		call_ranged_return_hooks(db_info);
 		stree = __pop_fake_cur_stree();
 		if (!db_info->cull)
 			merge_fake_stree(&db_info->stree, stree);
@@ -1108,9 +1109,20 @@
 	ret_range = cast_rl(get_type(db_info->expr), ret_range);
 
 	if (type == INTERNAL) {
+		struct smatch_state *state;
+
 		set_state(-1, "unnull_path", NULL, &true_state);
 		__add_return_comparison(strip_expr(db_info->expr), ret_str);
 		__add_return_to_param_mapping(db_info->expr, ret_str);
+		/*
+		 * We want to store the return values so that we can split the strees
+		 * in smatch_db.c.  This uses set_state() directly because it's not a
+		 * real smatch_extra state.
+		 */
+		snprintf(buf, sizeof(buf), "return %p", db_info->expr);
+		state = alloc_estate_rl(ret_range);
+		set_state(SMATCH_EXTRA, buf, NULL, state);
+		store_return_state(db_info, ret_str, state);
 	}
 
 	FOR_EACH_PTR(db_return_states_list, tmp) {
@@ -1118,13 +1130,6 @@
 			tmp->callback(db_info->expr, param, key, value);
 	} END_FOR_EACH_PTR(tmp);
 
-	/*
-	 * We want to store the return values so that we can split the strees
-	 * in smatch_db.c.  This uses set_state() directly because it's not a
-	 * real smatch_extra state.
-	 */
-	snprintf(buf, sizeof(buf), "return %p", db_info->expr);
-	set_state(SMATCH_EXTRA, buf, NULL, alloc_estate_rl(ret_range));
 
 	return 0;
 }
@@ -1148,6 +1153,7 @@
 	__unnullify_path();
 	sql_select_return_states("return_id, return, type, parameter, key, value",
 			expr, db_return_states_callback, &db_info);
+	call_ranged_return_hooks(&db_info);
 	stree = __pop_fake_cur_stree();
 	if (!db_info.cull)
 		merge_fake_stree(&db_info.stree, stree);
--- old/usr/src/tools/smatch/src/smatch_helper.c	Tue Jan  7 08:01:55 2020
+++ new/usr/src/tools/smatch/src/smatch_helper.c	Tue Jan  7 08:01:55 2020
@@ -299,6 +299,17 @@
 		append(buf, tmp, len);
 		return;
 	}
+	case EXPR_FVALUE: {
+		sval_t sval = {};
+		char tmp[25];
+
+		*complicated = 1;
+		if (!get_value(expr, &sval))
+			return;
+		snprintf(tmp, 25, "%s", sval_to_numstr(sval));
+		append(buf, tmp, len);
+		return;
+	}
 	case EXPR_STRING:
 		append(buf, "\"", len);
 		if (expr->string)
@@ -1066,6 +1077,22 @@
 	return get_param_num_from_sym(sym);
 }
 
+struct symbol *get_param_sym_from_num(int num)
+{
+	struct symbol *sym;
+	int i;
+
+	if (!cur_func_sym)
+		return NULL;
+
+	i = 0;
+	FOR_EACH_PTR(cur_func_sym->ctype.base_type->arguments, sym) {
+		if (i++ == num)
+			return sym;
+	} END_FOR_EACH_PTR(sym);
+	return NULL;
+}
+
 int ms_since(struct timeval *start)
 {
 	struct timeval end;
--- old/usr/src/tools/smatch/src/smatch_implied.c	Tue Jan  7 08:01:55 2020
+++ new/usr/src/tools/smatch/src/smatch_implied.c	Tue Jan  7 08:01:55 2020
@@ -142,10 +142,13 @@
 		return 0;
 
 	if (rl_intersection(true_rl, false_rl)) {
-		sm_perror("parsing (%s (%s) %s %s)",
-			sm->name, sm->state->name, show_special(comparison), show_rl(rl));
-		sm_msg("true_rl = %s false_rl = %s intersection = %s",
-		       show_rl(true_rl), show_rl(false_rl), show_rl(rl_intersection(true_rl, false_rl)));
+		/*
+		 * Normally these won't intersect, but one exception is when
+		 * we're dealing with mtags.  We have a long list of mtags and
+		 * then negate the list.  Now it's over the limit for mtag list
+		 * length and we squash it down to 4096-ptr_max.  So then it's
+		 * possible for the true and false rl to overlap.
+		 */
 		return 0;
 	}
 
@@ -807,6 +810,31 @@
 		return handle_zero_comparison(expr, implied_true, implied_false);
 }
 
+static int handled_by_parsed_conditions(struct expression *expr,
+					struct stree **implied_true,
+					struct stree **implied_false)
+{
+	struct state_list *true_stack = NULL;
+	struct state_list *false_stack = NULL;
+	struct stree *pre_stree;
+	struct sm_state *sm;
+
+	sm = parsed_condition_implication_hook(expr, &true_stack, &false_stack);
+	if (!sm)
+		return 0;
+
+	pre_stree = clone_stree(__get_cur_stree());
+
+	*implied_true = filter_stack(sm, pre_stree, false_stack, true_stack);
+	*implied_false = filter_stack(sm, pre_stree, true_stack, false_stack);
+
+	free_stree(&pre_stree);
+	free_slist(&true_stack);
+	free_slist(&false_stack);
+
+	return 1;
+}
+
 static int handled_by_stored_conditions(struct expression *expr,
 					struct stree **implied_true,
 					struct stree **implied_false)
@@ -837,14 +865,15 @@
 static struct stree *extra_saved_implied_true;
 static struct stree *extra_saved_implied_false;
 
-static void separate_extra_states(struct stree **implied_true,
-				  struct stree **implied_false)
+static void separate_implication_states(struct stree **implied_true,
+					 struct stree **implied_false,
+					 int owner)
 {
 	struct sm_state *sm;
 
-	/* We process extra states later to preserve the implications. */
+	/* We process these states later to preserve the implications. */
 	FOR_EACH_SM(*implied_true, sm) {
-		if (sm->owner == SMATCH_EXTRA)
+		if (sm->owner == owner)
 			overwrite_sm_state_stree(&extra_saved_implied_true, sm);
 	} END_FOR_EACH_SM(sm);
 	FOR_EACH_SM(extra_saved_implied_true, sm) {
@@ -852,7 +881,7 @@
 	} END_FOR_EACH_SM(sm);
 
 	FOR_EACH_SM(*implied_false, sm) {
-		if (sm->owner == SMATCH_EXTRA)
+		if (sm->owner == owner)
 			overwrite_sm_state_stree(&extra_saved_implied_false, sm);
 	} END_FOR_EACH_SM(sm);
 	FOR_EACH_SM(extra_saved_implied_false, sm) {
@@ -864,11 +893,16 @@
 			  struct stree **implied_true,
 			  struct stree **implied_false)
 {
-	if (handled_by_comparison_hook(expr, implied_true, implied_false))
+	if (handled_by_parsed_conditions(expr, implied_true, implied_false))
 		return;
 
+	if (handled_by_comparison_hook(expr, implied_true, implied_false)) {
+		separate_implication_states(implied_true, implied_false, comparison_id);
+		return;
+	}
+
 	if (handled_by_extra_states(expr, implied_true, implied_false)) {
-		separate_extra_states(implied_true, implied_false);
+		separate_implication_states(implied_true, implied_false, SMATCH_EXTRA);
 		return;
 	}
 
@@ -1138,8 +1172,8 @@
 	add_hook(&save_implications_hook, CONDITION_HOOK);
 	add_hook(&set_implied_states, CONDITION_HOOK);
 	add_hook(&__extra_match_condition, CONDITION_HOOK);
-	add_hook(&set_extra_implied_states, CONDITION_HOOK);
 	add_hook(&__comparison_match_condition, CONDITION_HOOK);
+	add_hook(&set_extra_implied_states, CONDITION_HOOK);
 	add_hook(&__stored_condition, CONDITION_HOOK);
 	add_hook(&match_end_func, END_FUNC_HOOK);
 }
--- old/usr/src/tools/smatch/src/smatch_math.c	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_math.c	Tue Jan  7 08:01:56 2020
@@ -1398,6 +1398,9 @@
 	case EXPR_VALUE:
 		sval = sval_from_val(expr, expr->value);
 		break;
+	case EXPR_FVALUE:
+		sval = sval_from_fval(expr, expr->fvalue);
+		break;
 	case EXPR_PREOP:
 		handle_preop_rl(expr, implied, recurse_cnt, &rl, &sval);
 		break;
--- /dev/null	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_parsed_conditions.c	Tue Jan  7 08:01:56 2020
@@ -0,0 +1,121 @@
+/*
+ * Copyright (C) 2019 Oracle.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see http://www.gnu.org/copyleft/gpl.txt
+ */
+
+/*
+ * The problem here is something like this:
+ *
+ * return (blah() || whatever()) ? NULL : some_function();
+ *
+ * When we are parsing this what happens is that we first parse all the
+ * expressions "(blah() || whatever()) ? NULL : some_function();" and then
+ * we parse the return statement.
+ *
+ * When we parse the return statement, we say "Oh, this is a conditional.  Let's
+ * get all the implications for true and false."  But because
+ * "(blah() || whatever())" is a function pointer, that means there aren't any
+ * implications.
+ *
+ * So what this module does is it ties the implications to the expression
+ * pointer so that we can retreive them easily.  It's similar to Smatch stored
+ * implications but it doesn't save condition, it saves the pointer.
+ *
+ * We ignore pre loop conditions which Smatch parses twice.
+ *
+ */
+
+#include "smatch.h"
+#include "smatch_slist.h"
+
+static int my_id;
+
+STATE(true_path);
+STATE(false_path);
+
+void record_condition(struct expression *expr)
+{
+	char name[32];
+	sval_t val;
+
+	if (get_value(expr, &val))
+		return;
+
+	if (__in_pre_condition)
+		return;
+
+	snprintf(name, sizeof(name), "condition %p", expr);
+	set_true_false_states(my_id, name, NULL, &true_path, &false_path);
+}
+
+void register_parsed_conditions(int id)
+{
+	my_id = id;
+	add_hook(&record_condition, CONDITION_HOOK);
+}
+
+static void filter_by_sm(struct sm_state *sm,
+		       struct state_list **true_stack,
+		       struct state_list **false_stack)
+{
+	if (!sm)
+		return;
+
+	if (sm->state == &true_path)
+		add_ptr_list(true_stack, sm);
+	else if (sm->state == &false_path)
+		add_ptr_list(false_stack, sm);
+
+	if (sm->merged) {
+		filter_by_sm(sm->left, true_stack, false_stack);
+		filter_by_sm(sm->right, true_stack, false_stack);
+	}
+}
+
+struct sm_state *parsed_condition_implication_hook(struct expression *expr,
+				struct state_list **true_stack,
+				struct state_list **false_stack)
+{
+	struct state_list *tmp_true = NULL;
+	struct state_list *tmp_false = NULL;
+	struct sm_state *sm, *tmp;
+	char name[32];
+
+	snprintf(name, sizeof(name), "condition %p", expr);
+
+	sm = get_sm_state(my_id, name, NULL);
+	if (!sm)
+		return NULL;
+	if (!sm->merged)
+		return NULL;
+
+	filter_by_sm(sm, &tmp_true, &tmp_false);
+	if (!tmp_true && !tmp_false)
+		return NULL;
+
+	FOR_EACH_PTR(tmp_true, tmp) {
+		add_ptr_list(true_stack, tmp);
+	} END_FOR_EACH_PTR(tmp);
+
+	FOR_EACH_PTR(tmp_false, tmp) {
+		add_ptr_list(false_stack, tmp);
+	} END_FOR_EACH_PTR(tmp);
+
+	free_slist(&tmp_true);
+	free_slist(&tmp_false);
+
+	return sm;
+}
+
--- old/usr/src/tools/smatch/src/smatch_ranges.c	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_ranges.c	Tue Jan  7 08:01:56 2020
@@ -134,6 +134,9 @@
 	unsigned long long mask;
 	int bits = type_bits(type);
 
+	if (type_is_fp(min.type) && !type_is_fp(type))
+		return 0;
+
 	if (bits >= type_bits(min.type))
 		return 0;
 
@@ -432,6 +435,13 @@
 	const char *start = c;
 	sval_t ret;
 
+	if (type == &float_ctype)
+		return sval_type_fval(type, strtof(start, (char **)endp));
+	else if (type == &double_ctype)
+		return sval_type_fval(type, strtod(start, (char **)endp));
+	else if (type == &ldouble_ctype)
+		return sval_type_fval(type, strtold(start, (char **)endp));
+
 	if (!strncmp(start, "max", 3)) {
 		ret = sval_type_max(type);
 		c += 3;
@@ -564,7 +574,7 @@
 				break;
 		}
 		if (*c != '-') {
-			sm_msg("debug XXX: trouble parsing %s c = %s", str, c);
+			sm_debug("XXX: trouble parsing %s c = %s", str, c);
 			break;
 		}
 		c++;
--- old/usr/src/tools/smatch/src/smatch_scripts/build_generic_data.sh	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_scripts/build_generic_data.sh	Tue Jan  7 08:01:56 2020
@@ -59,7 +59,7 @@
 	KERNEL_CROSS_COMPILE="CROSS_COMPILE=$CROSS_COMPILE"
 fi
 
-make $KERNEL_ARCH $KERNEL_CROSS_COMPILE -j${NR_CPU} CHECK="$BIN_DIR/smatch --call-tree --info --param-mapper --spammy --file-output" $TARGET
+make $KERNEL_ARCH $KERNEL_CROSS_COMPILE -j${NR_CPU} CHECK="$BIN_DIR/smatch --call-tree --info --spammy --file-output" $TARGET
 
 find -name \*.c.smatch -exec cat \{\} \; -exec rm \{\} \; > smatch_warns.txt
 
--- old/usr/src/tools/smatch/src/smatch_scripts/build_kernel_data.sh	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_scripts/build_kernel_data.sh	Tue Jan  7 08:01:56 2020
@@ -36,7 +36,7 @@
 fi
 
 BUILD_STATUS=0
-$SCRIPT_DIR/test_kernel.sh --call-tree --info --param-mapper --spammy --data=$DATA_DIR || BUILD_STATUS=$?
+$SCRIPT_DIR/test_kernel.sh --call-tree --info --spammy --data=$DATA_DIR || BUILD_STATUS=$?
 
 for i in $SCRIPT_DIR/gen_* ; do
 	$i smatch_warns.txt -p=kernel
--- old/usr/src/tools/smatch/src/smatch_scripts/gen_rosenberg_funcs.sh	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_scripts/gen_rosenberg_funcs.sh	Tue Jan  7 08:01:56 2020
@@ -25,6 +25,7 @@
 ${bin_dir}/trace_params.pl $file nla_put 3 >> $tmp
 ${bin_dir}/trace_params.pl $file snd_timer_user_append_to_tqueue 1 >> $tmp
 ${bin_dir}/trace_params.pl $file __send_signal 1 >> $tmp
+${bin_dir}/trace_params.pl $file usb_bulk_msg 2 >> $tmp
 
 cat $tmp | sort -u > $tmp2
 mv $tmp2 $tmp
--- old/usr/src/tools/smatch/src/smatch_scripts/kpatch.sh	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_scripts/kpatch.sh	Tue Jan  7 08:01:56 2020
@@ -99,8 +99,10 @@
 
 git commit $AMEND -F $MSG_FILE
 
-to_addr=$(./scripts/get_maintainer.pl -f --noroles --norolestats $fullname | head -n 1)
-cc_addr=$(./scripts/get_maintainer.pl -f --noroles --norolestats $fullname | tail -n +2 | \
+git format-patch HEAD^ --stdout >> $MSG_FILE
+
+to_addr=$(./scripts/get_maintainer.pl --noroles --norolestats $MSG_FILE | head -n 1)
+cc_addr=$(./scripts/get_maintainer.pl --noroles --norolestats $MSG_FILE | tail -n +2 | \
     perl -ne 's/\n$/, /; print')
 cc_addr="$cc_addr, kernel-janitors@vger.kernel.org"
 
@@ -118,3 +120,4 @@
 read unused
 
 mutt -H $MAIL_FILE
+rm -f $MSG_FILE
--- old/usr/src/tools/smatch/src/smatch_states.c	Tue Jan  7 08:01:56 2020
+++ new/usr/src/tools/smatch/src/smatch_states.c	Tue Jan  7 08:01:56 2020
@@ -1095,6 +1095,15 @@
 	struct stree *implied_stree;
 
 	stree = pop_stree(&switch_stack);
+	if (!stree) {
+		/*
+		 * If the cur_stree was NULL before the start of the switch
+		 * statement then we don't want to unnullify it.
+		 *
+		 */
+		push_stree(&switch_stack, stree);
+		return;
+	}
 	implied_stree = __implied_case_stree(switch_expr, case_rl, &remaining_cases, &stree);
 	merge_stree(&cur_stree, implied_stree);
 	free_stree(&implied_stree);
--- old/usr/src/tools/smatch/src/smatch_sval.c	Tue Jan  7 08:01:57 2020
+++ new/usr/src/tools/smatch/src/smatch_sval.c	Tue Jan  7 08:01:57 2020
@@ -74,6 +74,15 @@
 	return ret;
 }
 
+sval_t sval_type_fval(struct symbol *type, long double fval)
+{
+	sval_t ret;
+
+	ret.type = &ldouble_ctype;
+	ret.ldvalue = fval;
+	return sval_cast(type, ret);
+}
+
 sval_t sval_from_val(struct expression *expr, long long val)
 {
 	sval_t ret;
@@ -85,6 +94,17 @@
 	return ret;
 }
 
+sval_t sval_from_fval(struct expression *expr, long double fval)
+{
+	sval_t ret;
+
+	ret.type = &ldouble_ctype;
+	ret.ldvalue = fval;
+	ret = sval_cast(get_type(expr), ret);
+
+	return ret;
+}
+
 int sval_is_ptr(sval_t sval)
 {
 	if (!sval.type)
@@ -92,6 +112,11 @@
 	return (sval.type->type == SYM_PTR || sval.type->type == SYM_ARRAY);
 }
 
+bool sval_is_fp(sval_t sval)
+{
+	return type_is_fp(sval.type);
+}
+
 int sval_unsigned(sval_t sval)
 {
 	if (is_ptr_type(sval.type))
@@ -134,10 +159,25 @@
 	return !sval_is_negative(sval);
 }
 
+static bool fp_is_min(sval_t sval)
+{
+	if (sval.type == &float_ctype)
+		return sval.fvalue == -FLT_MAX;
+	if (sval.type == &double_ctype)
+		return sval.dvalue == -DBL_MAX;
+	if (sval.type == &ldouble_ctype)
+		return sval.ldvalue == -LDBL_MAX;
+	sm_perror("%s: bad type: '%s'", __func__, type_to_str(sval.type));
+	return false;
+}
+
 int sval_is_min(sval_t sval)
 {
 	sval_t min = sval_type_min(sval.type);
 
+	if (sval_is_fp(sval))
+		return fp_is_min(sval);
+
 	if (sval_unsigned(sval)) {
 		if (sval.uvalue == 0)
 			return 1;
@@ -147,10 +187,25 @@
 	return (sval.value <= min.value);
 }
 
+static bool fp_is_max(sval_t sval)
+{
+	if (sval.type == &float_ctype)
+		return sval.fvalue == FLT_MAX;
+	if (sval.type == &double_ctype)
+		return sval.dvalue == DBL_MAX;
+	if (sval.type == &ldouble_ctype)
+		return sval.ldvalue == LDBL_MAX;
+	sm_perror("%s: bad type: '%s'", __func__, type_to_str(sval.type));
+	return false;
+}
+
 int sval_is_max(sval_t sval)
 {
 	sval_t max = sval_type_max(sval.type);
 
+	if (sval_is_fp(sval))
+		return fp_is_max(sval);
+
 	if (sval_unsigned(sval))
 		return (sval.uvalue >= max.value);
 	return (sval.value >= max.value);
@@ -160,6 +215,10 @@
 {
 	if (sval_is_min(sval))
 		return 1;
+
+	if (sval_is_fp(sval))
+		return 0;
+
 	if (sval_signed(sval) && sval.value == SHRT_MIN)
 		return 1;
 	if (sval_signed(sval) && sval.value == INT_MIN)
@@ -173,6 +232,10 @@
 {
 	if (sval_is_max(sval))
 		return 1;
+
+	if (sval_is_fp(sval))
+		return 0;
+
 	if (sval.uvalue == SHRT_MAX)
 		return 1;
 	if (sval.uvalue == INT_MAX)
@@ -193,6 +256,9 @@
 
 int sval_is_negative_min(sval_t sval)
 {
+	if (sval_is_fp(sval))
+		return 0;
+
 	if (!sval_is_negative(sval))
 		return 0;
 	return sval_is_min(sval);
@@ -254,6 +320,13 @@
 
 int sval_fits(struct symbol *type, sval_t sval)
 {
+	/* everything fits into floating point */
+	if (type_is_fp(type))
+		return 1;
+	/* floating points don't fit into int */
+	if (type_is_fp(sval.type))
+		return 0;
+
 	if (sval_too_low(type, sval))
 		return 0;
 	if (sval_too_high(type, sval))
@@ -261,6 +334,71 @@
 	return 1;
 }
 
+static sval_t cast_to_fp(struct symbol *type, sval_t sval)
+{
+	sval_t ret = {};
+
+	ret.type = type;
+	if (type == &float_ctype) {
+		if (!sval_is_fp(sval)) {
+			if (sval_unsigned(sval))
+				ret.fvalue = sval.uvalue;
+			else
+				ret.fvalue = sval.value;
+		} else if (sval.type == &float_ctype)
+			ret.fvalue = sval.fvalue;
+		else if (sval.type == &double_ctype)
+			ret.fvalue = sval.dvalue;
+		else
+			ret.fvalue = sval.ldvalue;
+	} else if (type == &double_ctype) {
+		if (!sval_is_fp(sval)) {
+			if (sval_unsigned(sval))
+				ret.dvalue = sval.uvalue;
+			else
+				ret.dvalue = sval.value;
+		} else if (sval.type == &float_ctype)
+			ret.dvalue = sval.fvalue;
+		else if (sval.type == &double_ctype)
+			ret.dvalue = sval.dvalue;
+		else
+			ret.dvalue = sval.ldvalue;
+	} else if (type == &ldouble_ctype) {
+		if (!sval_is_fp(sval)) {
+			if (sval_unsigned(sval))
+				ret.ldvalue = (long double)sval.uvalue;
+			else
+				ret.ldvalue = (long double)sval.value;
+		} else if (sval.type == &float_ctype)
+			ret.ldvalue = sval.fvalue;
+		else if (sval.type == &double_ctype)
+			ret.ldvalue = sval.dvalue;
+		else
+			ret.ldvalue = sval.ldvalue;
+	} else {
+		sm_perror("%s: bad type: %s", __func__, type_to_str(type));
+	}
+
+	return ret;
+}
+
+static sval_t cast_from_fp(struct symbol *type, sval_t sval)
+{
+	sval_t ret = {};
+
+	ret.type = &llong_ctype;
+	if (sval.type == &float_ctype)
+		ret.value = sval.fvalue;
+	else if (sval.type == &double_ctype)
+		ret.value = sval.dvalue;
+	else if (sval.type == &ldouble_ctype)
+		ret.value = sval.ldvalue;
+	else
+		sm_perror("%s: bad type: %s", __func__, type_to_str(type));
+
+	return sval_cast(type, ret);
+}
+
 sval_t sval_cast(struct symbol *type, sval_t sval)
 {
 	sval_t ret;
@@ -268,6 +406,11 @@
 	if (!type)
 		type = &int_ctype;
 
+	if (type_is_fp(type))
+		return cast_to_fp(type, sval);
+	if (type_is_fp(sval.type))
+		return cast_from_fp(type, sval);
+
 	ret.type = type;
 	switch (sval_bits(ret)) {
 	case 1:
@@ -626,10 +769,29 @@
 	return fls_mask(sval.uvalue);
 }
 
+static char *fp_to_str(sval_t sval)
+{
+	char buf[32];
+
+	if (sval.type == &float_ctype)
+		snprintf(buf, sizeof(buf), "%f", sval.fvalue);
+	else if (sval.type == &double_ctype)
+		snprintf(buf, sizeof(buf), "%e", sval.dvalue);
+	else if (sval.type == &ldouble_ctype) {
+		snprintf(buf, sizeof(buf), "%Lf", sval.ldvalue);
+	} else
+		snprintf(buf, sizeof(buf), "nan");
+
+	return alloc_sname(buf);
+}
+
 const char *sval_to_str(sval_t sval)
 {
-	char buf[30];
+	char buf[32];
 
+	if (sval_is_fp(sval))
+		return fp_to_str(sval);
+
 	if (sval_is_ptr(sval) && sval.value == valid_ptr_max)
 		return "ptr_max";
 	if (sval_unsigned(sval) && sval.value == ULLONG_MAX)
@@ -671,7 +833,7 @@
 	    !is_ptr_type(sval.type))
 		return sval_to_str(sval);
 
-	if (sval.uvalue >= -4905ULL) {
+	if (!sval_is_fp(sval) && sval.uvalue >= -4905ULL) {
 		snprintf(buf, sizeof(buf), "(%lld)", sval.value);
 		return alloc_sname(buf);
 	}
@@ -683,6 +845,9 @@
 {
 	char buf[30];
 
+	if (type_is_fp(sval.type))
+		return fp_to_str(sval);
+
 	if (sval_unsigned(sval))
 		snprintf(buf, sizeof(buf), "%llu", sval.value);
 	else if (sval.value < 0)
--- old/usr/src/tools/smatch/src/smatch_type.c	Tue Jan  7 08:01:57 2020
+++ new/usr/src/tools/smatch/src/smatch_type.c	Tue Jan  7 08:01:57 2020
@@ -77,6 +77,24 @@
 	if (!right)
 		return NULL;
 
+	if (type_is_fp(left)) {
+		if (type_is_fp(right)) {
+			if (type_bits(left) > type_bits(right))
+				return left;
+			return right;
+		}
+		return left;
+	}
+
+	if (type_is_fp(right)) {
+		if (type_is_fp(left)) {
+			if (type_bits(right) > type_bits(left))
+				return right;
+			return left;
+		}
+		return right;
+	}
+
 	if (expr->op == '-' &&
 	    (is_ptr_type(left) && is_ptr_type(right)))
 		return ssize_t_ctype;
@@ -143,10 +161,30 @@
 	return get_real_base_type(sym);
 }
 
+static struct symbol *handle__builtin_choose_expr(struct expression *expr)
+{
+	struct expression *const_expr, *expr1, *expr2;
+	sval_t sval;
+
+	const_expr = get_argument_from_call_expr(expr->args, 0);
+	expr1 = get_argument_from_call_expr(expr->args, 1);
+	expr2 = get_argument_from_call_expr(expr->args, 2);
+
+	if (!get_value(const_expr, &sval) || !expr1 || !expr2)
+		return NULL;
+	if (sval.value)
+		return get_type(expr1);
+	else
+		return get_type(expr2);
+}
+
 static struct symbol *get_return_type(struct expression *expr)
 {
 	struct symbol *tmp;
 
+	if (sym_name_is("__builtin_choose_expr", expr->fn))
+		return handle__builtin_choose_expr(expr);
+
 	tmp = get_type(expr->fn);
 	if (!tmp)
 		return NULL;
@@ -403,10 +441,27 @@
 	return 0;
 }
 
+static sval_t fp_max(struct symbol *type)
+{
+	sval_t ret = { .type = type };
+
+	if (type == &float_ctype)
+		ret.fvalue = FLT_MAX;
+	else if (type == &double_ctype)
+		ret.dvalue = DBL_MAX;
+	else
+		ret.ldvalue = LDBL_MAX;
+
+	return ret;
+}
+
 sval_t sval_type_max(struct symbol *base_type)
 {
 	sval_t ret;
 
+	if (type_is_fp(base_type))
+		return fp_max(base_type);
+
 	if (!base_type || !type_bits(base_type))
 		base_type = &llong_ctype;
 	ret.type = base_type;
@@ -415,10 +470,27 @@
 	return ret;
 }
 
+static sval_t fp_min(struct symbol *type)
+{
+	sval_t ret = { .type = type };
+
+	if (type == &float_ctype)
+		ret.fvalue = -FLT_MAX;
+	else if (type == &double_ctype)
+		ret.dvalue = -DBL_MAX;
+	else
+		ret.ldvalue = -LDBL_MAX;
+
+	return ret;
+}
+
 sval_t sval_type_min(struct symbol *base_type)
 {
 	sval_t ret;
 
+	if (type_is_fp(base_type))
+		return fp_min(base_type);
+
 	if (!base_type || !type_bits(base_type))
 		base_type = &llong_ctype;
 	ret.type = base_type;
--- /dev/null	Tue Jan  7 08:01:57 2020
+++ new/usr/src/tools/smatch/src/validation/sm_float1.c	Tue Jan  7 08:01:57 2020
@@ -0,0 +1,20 @@
+#include "check_debug.h"
+
+float frob(float x)
+{
+	return x;
+}
+
+int main(int argc, char *argv[])
+{
+	__smatch_implied((long long)frob(3.14));
+}
+
+/*
+ * check-name: smatch floating point #1
+ * check-command: smatch -I.. sm_float1.c
+ *
+ * check-output-start
+sm_float1.c:10 main() implied: frob(3.140000e+00) = '3'
+ * check-output-end
+ */
